export type ACLAction = 'accept';

export type SourceType = 
  | 'any' 
  | 'user' 
  | 'group' 
  | 'ip' 
  | 'subnet' 
  | 'host' 
  | 'tag' 
  | 'autogroup';

export type DestinationType = 
  | 'any' 
  | 'user' 
  | 'group' 
  | 'ip' 
  | 'subnet' 
  | 'host' 
  | 'tag' 
  | 'autogroup';

export type Protocol = 
  | 'tcp' 
  | 'udp' 
  | 'icmp' 
  | 'sctp' 
  | 'igmp' 
  | 'esp' 
  | 'ah' 
  | 'gre' 
  | 'ipip' 
  | 'dccp' 
  | 'all';

export type PortDefinition = 
  | '*' 
  | number 
  | string; // For ranges like "1000-2000" or multiple ports "80,443"

export interface SourceEntry {
  type: SourceType;
  value: string;
}

export interface DestinationEntry {
  type: DestinationType;
  value: string;
  ports: PortDefinition;
}

export interface ACLRule {
  action: ACLAction;
  src: SourceEntry[];
  proto?: Protocol;
  dst: DestinationEntry[];
}

export interface ACLPolicy {
  acls: ACLRule[];
}
